//вывод 8 платы подключаем к выводу ST_CP 
//вывод 12 платы подключаем к выводу SH_CP 
//вывод 11 платы подключаем к выводу DS 

int latchPin = 8; 
int clockPin = 12; 
int dataPin = 11; 
  
void setup() 
{ 
  //устанавливаем режим OUTPUT 

  pinMode(latchPin, OUTPUT); 
  pinMode(dataPin, OUTPUT);   
  pinMode(clockPin, OUTPUT); 

  Serial.begin(9600); 
  Serial.println("reset"); 
} 
  
void loop() 
{ 
  if (Serial.available() > 0) //если есть доступные данные считываем байт
{ 
    // Символы от '0' до '9' представлены в ASCII таблице значениями от 48 до 57. Поэтому, если пользователь вводит число от 0 до 9 в ASCII, вы можете вычесть 48 для получения фактического значения: 

    int bitToSet = Serial.read() - 48; 
/*
  Serial.read() - cчитывает очередной доступный байт из буфера последовательного соединения.

*/
  
//Записываем в текущий бит регистра сдвига высокий уровень сигнала:
    registerWrite(bitToSet, HIGH); 
  } 
} 
  
// Этот метод записывает байт в регистр сдвига
void registerWrite(int whichPin, int whichState) 
{ 
// инициализируем и обнуляем байт 
  byte bitsToSend = 0; 
  
  //Отключаем вывод на регистре 
  digitalWrite(latchPin, LOW); 
  
  // устанавливаем HIGH в соответствующем бите 
/*
  bitWrite() - изменяет состояние указанного бита переменной.
bitWrite(x, n, b), где x: числовая переменная, у которой необходимо изменить бит; n: номер бита, состояние которого необходимо изменить. Нумерация начинается с младшего значащего бита (крайнего правого) с номером 0; b: новое значение бита (0 или 1)
*/

  bitWrite(bitsToSend, whichPin, whichState); 
  
  // проталкиваем байт в регистр 
  shiftOut(dataPin, clockPin, MSBFIRST, bitsToSend); 
  
    // "защелкиваем" регистр, чтобы байт появился на его выходах 
  digitalWrite(latchPin, HIGH); 
}

